=== requirements.txt ===
build
cmake>=3.28
imageio
ninja
numpy
pillow
pybind11==2.10.4
scikit-build-core==0.10.5
scipy
setuptools>=43
tbump==6.11.0
wheel
