=== debian/changelog ===
halide (19.0.0-6) unstable; urgency=medium

  * Decrease debug info verbosity/size. Refs. #1097128
  * Partial(?) GCC15 FTBFS fix. Refs. #1096795

 -- Roman Lebedev <lebedev.ri@gmail.com>  Wed, 26 Feb 2025 23:18:26 +0300

halide (19.0.0-5) unstable; urgency=medium

  * Make other parts of `mullapudi2016_reorder` test even more lax to timings.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Tue, 21 Jan 2025 20:03:28 +0300

halide (19.0.0-4) unstable; urgency=medium

  * Unbreak the build - should be built *WITH* assertions...
    See https://github.com/halide/Halide/issues/8550.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Mon, 20 Jan 2025 21:57:09 +0300

halide (19.0.0-3) unstable; urgency=medium

  * package's i386 build i s failing with OOM related to debug info,
    so rip out DWZ crutches, enable DWARF5, split+compressed debug info.
    Decreases total amd64 dbgsym size 32Mb -> 4.8Mb, and makes build faster.
    This either solves it, or i386 build needs to be disabled.
  * Respect specified job count when running CTest.
  * Install few more doc files that were missed.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Wed, 08 Jan 2025 23:58:22 +0300

halide (19.0.0-2) unstable; urgency=medium

  * Make package buildable on i386 again.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Mon, 23 Dec 2024 02:09:40 +0300

halide (19.0.0-1) unstable; urgency=medium

  * Update to latest upstream major release
  * Build with/against LLVM19
  * Refresh and reorder patches, drop patches applied upstream
  * Stop specifying Release CMake Build Mode, this is required
    for `find_package(flatbuffers)` to work,
    since it only provides `None` mode.
  * Looks like WebAssembly target can no longer be turned off,
    so `liblld` is now a dependency.
  * `libhalide-dev` no longer depends on python,
    `python3-halide19-dev` has been split off.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Wed, 18 Dec 2024 00:26:37 +0300
